{
===============================================================================
  Copyright (©) 2007. Rodax Software.
===============================================================================
  Los contenidos de este fichero son propiedad de Rodax Software titular del
  copyright. Este fichero sólo podrá ser copiado, distribuido y utilizado,
  en su totalidad o en parte, con el permiso escrito de Rodax Software, o de
  acuerdo con los términos y condiciones establecidas en el acuerdo/contrato
  bajo el que se suministra.
  -----------------------------------------------------------------------------
  Web:  www.rodax-software.com
===============================================================================
  Fecha primera versión: 14-11-2007
  Versión actual: 1.0.0
  Fecha versión actual: 14-11-2007
===============================================================================
  Modificaciones:

    Fecha         Comentarios
    ---------------------------------------------------------------------------
===============================================================================
}

unit InformeEtiquetasClientes;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, InformeBase, FR_IBXDB, FR_Shape, FR_Class, DB, IBCustomDataSet,
  IBQuery, FR_DSet, FR_DBSet, RdxEmpresaActiva;

type
  TdmInformeEtiquetasClientes = class(TdmInformeBase)
    dsTablaClientes: TfrDBDataSet;
    TablaClientes: TIBQuery;
  private
    FNombreIni: String;
    FNombreFin: String;
  protected
    procedure RellenarCabecera(Band: TfrBand); override;
    procedure PrepararConsultas; override;
  public
    constructor Create(AOwner: TComponent); override;
  published
    property NombreIni : String read FNombreIni write FNombreIni;
    property NombreFin : String read FNombreFin write FNombreFin;
  end;

var
  dmInformeEtiquetasClientes: TdmInformeEtiquetasClientes;

implementation

{$R *.dfm}

{ TdmInformeEtiquetasClientes }

constructor TdmInformeEtiquetasClientes.Create(AOwner: TComponent);
begin
  inherited;
  FNombreInforme := 'InformeEtiquetasClientes.frf';
end;

procedure TdmInformeEtiquetasClientes.PrepararConsultas;
begin
  inherited;
  with TablaClientes do
  begin
    Database := FBaseDatos;
    Transaction := FTransaccion;
    SQL.Clear;
    SQL.Add('select distinct CLIENTES.CODIGO, CLIENTES.NOMBRE, ');
    SQL.Add('case when SUCURSALESCLIENTE.NUMERO is null ');
    SQL.Add('then SUCURSALESCLIENTE.CALLE ');
    SQL.Add('else SUCURSALESCLIENTE.CALLE || '', '' || SUCURSALESCLIENTE.NUMERO');
    SQL.Add('end as DIRECCION, ');
    SQL.Add('SUCURSALESCLIENTE.CODIGOPOSTAL, SUCURSALESCLIENTE.POBLACION, SUCURSALESCLIENTE.PROVINCIA');

    SQL.Add('from contratoscliente');
    SQL.Add('left join CLIENTES on (CLIENTES.CODIGO = contratoscliente.codigocliente)');
    SQL.Add('left join SUCURSALESCLIENTE on (SUCURSALESCLIENTE.CODIGOCLIENTE = CLIENTES.CODIGO and SUCURSALESCLIENTE.TIPO = ''P'')');

    SQL.Add('where (ltrim(SUCURSALESCLIENTE.calle) <> '''')');
    SQL.Add('and (ltrim(SUCURSALESCLIENTE.codigopostal) <> '''')');
    SQL.Add('and (upper(CLIENTES.NOMBRE) between upper(:NOMBREINI) and upper(:NOMBREFIN))');
    SQL.Add('order by CLIENTES.NOMBRE');

    ParamByName('NOMBREINI').AsString := FNombreIni;
    ParamByName('NOMBREFIN').AsString := FNombreFin;
    Prepare;
  end;
end;

procedure TdmInformeEtiquetasClientes.RellenarCabecera(Band: TfrBand);
var
  iCont : Integer;
  Objeto : TfrView;
begin
  inherited;
  with Band do
  begin
     for iCont := 0 to Objects.Count - 1 do
      begin
        Objeto := Objects[iCont];
        if ((Objeto is TfrMemoView) and (Objeto.Name = 'CabParametros')) then
        begin
          with (Objeto as TfrMemoView) do
          begin
            Memo.Clear;
            Memo.Add('Rango de clientes: ' + FNombreIni + ' - ' + FNombreFin);
          end;
        end;
      end;
  end;
end;

end.

